#include <pthread.h>
#include <ruby.h>

struct Nthread
{
	pthread_t th;
	VALUE proc;
};

static void
nthread_mark(struct Nthread *nth)
{
	rb_gc_mark(nth->proc);
}

static void
free_nthread(struct Nthread *nth)
{
	if (nth->th) {
		pthread_join(nth->th, NULL);
	}
	//rb_xfree(nth->proc);
}

static VALUE
nthread_alloc(VALUE klass)
{
	struct Nthread *nth = ALLOC(struct Nthread);
	return Data_Wrap_Struct(klass, nthread_alloc, free_nthread, nth);
}

void* run_routine(void* args)
{
	struct Nthread *nth;
       	nth = args;

	rb_funcall(nth->proc, rb_intern("call"), 0);
	pthread_exit(NULL);
}


VALUE run(VALUE self, VALUE proc)
{
	struct Nthread *nth;
	pthread_t *pth;

	Data_Get_Struct(self, struct Nthread, nth);

	pth = &nth->th;
	nth->proc = proc;
	nthread_mark(nth);
	pthread_create(pth, NULL, run_routine, nth);

}

void Init_nthread(void)
{
	VALUE rb_cNthread;

	rb_cNthread = rb_define_class("Nthread", rb_cObject);
	rb_define_alloc_func(rb_cNthread, nthread_alloc);
	rb_define_method(rb_cNthread, "run", run, 1);
}
